<?php
/*
This file is part of Thomas Bley's moregroupware webmail2/calendar2/admin2 module. (tb-mgw)

More information:
-----------------

Simple Groupware Solutions Thomas Bley
Fichtenstr. 23
Germany, 85640 Putzbrunn

Contact:
--------

info@simple-groupware.de

http://www.simple-groupware.de


Copyright 2002-2003 Thomas Bley
tb-mgw is distributed under the terms of the GNU General Public License 

tb-mgw is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

tb-mgw is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with tb-mgw; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Init2
// Moregroupware.org


error_reporting  (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

if (isset($_GET["icals"])) {
  $icals = $_GET["icals"];
  store_calendar_cals(serialize($icals));
} else {
  $icals = "";
}

if (!is_array($icals)) {
  if (isset($_SESSION["MGW"]->settings["cal2_icals"]) and $_SESSION["MGW"]->settings["cal2_icals"]!="") {
    $icals = unserialize($_SESSION["MGW"]->settings["cal2_icals"]);
  }
}

if (!is_array($icals) or count($icals)==0) {
  $icals = array($_SESSION["MGW"]->username);
}

if ($myEnv["module"]=="overview") {
  $icals = array_merge(array($_SESSION["MGW"]->username),$_SESSION["MGW"]->groups);
}

$sort_entries = false;
$cal_entries = array();
$_SESSION["calendar2_ical"] = $icals;

$query_opts = array();
$query = "";
foreach ($icals as $ical) {
  if ($ical=="birthdays" && isModuleInstalled("contact")) {
    $sql = "select p.companyid,p.birthday,p.firstname,p.lastname,p.id from mgw_contacts as p where p.lastname!='' and p.birthday IS NOT NULL and (p.ispublic=1 or p.owner=".$_SESSION["MGW"]->userid.")";
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
      
    while($row = $res->FetchRow()) {
      if ($row["companyid"]!=0) {
        $sql = "select name1 from mgw_companies where id=".(int)$row["companyid"];
        if(!$res2 = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
        $row2 = $res2->FetchRow();
        $row["name1"] = $row2["name1"];
      } else {
        $row["name1"] = "";
      }
	  $birthday = mktime(0,0,0,substr($row['birthday'],5,2),substr($row['birthday'],8,2));
	  
      $birthday_str1 = $this_year.date("md",$birthday);
      $birthday2 = strtotime2("+1 day",$birthday);
      $birthday_str2 = date("Ymd",$birthday2);

      $company = "";
      if ($row["name1"]!="" and $row["companyid"]!=0) { $company = " (".$row["name1"].")"; }
    
	  $cal_entries[$birthday_str1][] = array(
		"dstart" => $birthday_str1,
		"dend" => $birthday_str2,
        "dsummary" => $hashmap["birthday"].": ".$row["firstname"]." ".$row["lastname"].$company,
        "dclass" => "private",
        "drep_freq" => "yearly",
        "drep_until" => "",
        "drep_count" => 0,
        "drep_interval" => 1,
        "drep_days" => "",
        "drep_exdate" => "",
        "dsequence" => 1,
		"ddesc" => "",
		"dlocation" => "",
        "dcategories" => "Birthday",
        "dcalendar" => "birthdays",
        "c_duser_id" => $_SESSION["MGW"]->userid,
        "duser_id" => 0, // $_SESSION["MGW"]->userid
        "id" => md5($_SERVER["HTTP_HOST"]).$row["id"]
	  );
	  $sort_entries = true;
    }
  } elseif ($ical!="") {
    $ical = urldecode($ical);
	
    if (is_numeric($ical)) $id_string = "root_modules_calendar2_groupcalendars_".(int)get_calendar_id($ical);
	  elseif ($ical[0]=="#") $id_string = "root_modules_calendar2_holidaycalendars_".(int)get_calendar_id($ical);
	  elseif ($ical[0]=="@") $id_string = "root_modules_calendar2_publiccalendars_".(int)get_calendar_id($ical);
	  else $id_string = "root_modules_calendar2_personalcalendars_".(int)get_calendar_id($ical);
	  
    if (queryRights2_bool($id_string."_read")) {
      $sql = "select dlocation from mgw_calendar2_cals where dcalendar=".$conn->Quote($ical);
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
      $row = $res->FetchRow();

	  if ($row["dlocation"]=="" or !strpos($row["dlocation"],"://")>0) {
	    if ($query!="") $query .= " or ";
	    $query .= "dcalendar=".$conn->Quote($ical);
      
	    $viewconfidential = false;
	    if (queryRights2_bool($id_string."_viewconfidential")) $viewconfidential = true;
	  
	    $viewprivate = false;
	    if (queryRights2_bool($id_string."_viewprivate")) $viewprivate = true;
	  
	    $query_opts[$ical] = array($viewconfidential,$viewprivate);
	  } else {
		$cal_entries = array_merge($cal_entries,preview_from_file($row["dlocation"],$ical));
      }
	}
  }
}

if ($query!="") {
      $sql = "select * from mgw_calendar2_ics where ".$query." order by dstart";
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
      
      while($row = $res->FetchRow()) {
	    if ($row["dhomepage"]!="" and !strpos("@".$row["dhomepage"],"://")>0) $row["dhomepage"] = "http://".$row["dhomepage"];

		$row["viewconfidential"] = $query_opts[$row["dcalendar"]][0];
		$row["viewprivate"] = $query_opts[$row["dcalendar"]][1];

        $cal_entries[$row["dstart"]][] = $row;
      }
}

if (count($cal_entries)>0) {
  foreach ($cal_entries as $cal2_entry_num_tmp=>$cal2_entry_tmp) {
    foreach ($cal2_entry_tmp as $cal2_entry_num=>$cal2_entry) {
	  if ($cal2_entry["dclass"]=="confidential" and !has_access($cal2_entry,"read")) {
		// confidential
	    $cal_entries[$cal2_entry_num_tmp][$cal2_entry_num] = array();
	  } elseif ($cal2_entry["dclass"]=="private" and !has_access($cal2_entry,"read")) {
		// private
	    $cal_entries[$cal2_entry_num_tmp][$cal2_entry_num] = array(
		   	"dstart" => $cal2_entry["dstart"],
		   	"dend" => $cal2_entry["dend"],
			"dsummary" => $hashmap["private"],
            "dcalendar" => $cal2_entry["dcalendar"],
            "c_duser_id" => $cal2_entry["c_duser_id"],
            "duser_id" => 0, // $cal2_entry["duser_id"]
			"ddesc" => "",
			"dlocation" => "",
	        "dclass" => "",
	        "dcategories" => "",
	        "drep_freq" => $cal2_entry["drep_freq"],
    	    "drep_until" => $cal2_entry["drep_until"],
        	"drep_count" => $cal2_entry["drep_count"],
	        "drep_interval" => $cal2_entry["drep_interval"],
    	    "drep_days" => $cal2_entry["drep_days"],
        	"drep_exdate" => $cal2_entry["drep_exdate"],
	        "dsequence" => $cal2_entry["dsequence"],
            "id" => $cal2_entry["id"],
	    );
	  }
	}
  }
}


/*
$holidays = array("holidays/JapanHolidays.ics"=>"JapanHolidays","holidays/USHolidays.ics"=>"Holidays_us_03");

foreach ($holidays as $import_cal_filename=>$import_cal_name) {

  $sdate=getDate(time());
  $now = $sdate["year"].twodigit($sdate["mon"]).twodigit($sdate["mday"])."T".twodigit($sdate["hours"]).twodigit($sdate["minutes"]).twodigit($sdate["seconds"]);

  preview_from_file($import_cal_filename,$import_cal_name);

  if (is_array($cal_entries[$import_cal_name]) and count($cal_entries[$import_cal_name])>0) {
    foreach ($cal_entries[$import_cal_name] as $entry) {
      $sql = "insert into mgw_calendar2_ics (id,dstart,dend,dsummary,dlocation,ddesc,drep_freq,drep_days,drep_until,drep_interval,drep_count,dclass,dnow,c_duser_id,duser_id,dcalendar,dcategories,dsequence,drep_exdate) values 
        (".mgw_genID('mgw__seq_calendar2_ics').",".$conn->Quote($entry["dstart"]).",".$conn->Quote($entry["dend"]).",".$conn->Quote($entry["dsummary"]).",".$conn->Quote($entry["dlocation"]).",".$conn->Quote($entry["ddesc"]).",".$conn->Quote($entry["drep_freq"]).",".$conn->Quote($entry["drep_days"]).",".$conn->Quote($entry["drep_until"]).",".(int)$entry["drep_interval"].",".(int)$entry["drep_count"].",".$conn->Quote($entry["dclass"]).",".$conn->Quote($now).",".$_SESSION["MGW"]->userid.",".$_SESSION["MGW"]->userid.",".$conn->Quote($import_cal_name).",".$conn->Quote($entry["dcategories"]).",0,".$conn->Quote($entry["drep_exdate"]).")";
//      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    }
  }
}
*/

if ($sort_entries) ksort($cal_entries);

if (isset($_GET["debug2"])) show_print_r($cal_entries);
// die;

?>