<?php
	
class Error {
	var $dieOnError = true;
	var $count = 0;
	
	/*************************
	* Constructor
	* @param Projekt name (optional)
	***/
	function Error() {
		$params = func_get_args();
		$this->project = isset($params[0]) ? $params[0] : '';
	}

	/*********************
	* Catch error. -> Save error in associative array. 
	* @param String variable name
	* @param String error location
	* @param String error message
	***/
	function catch($var, $location, $message) {
		$this->err[$this->count]["location"] = $location;
		$this->err[$this->count]["variable"] = $var;
		$this->err[$this->count]["message"] = $message;
		$this->count++;	
	}

	/*********************
	* Stop program on error?
	* @param boolean dieOnError
	***/
	function setDieOnError($boolean) {
		$this->dieOnError = $boolean;
	}
	/*********************
	* Return dieOnError status
	* @return boolean dieOnError
	***/
	function getDieOnError() {
		return $this->dieOnError;
	}
	/**********************
	* Print all errors to the screen
	***/
	function printErrors() {

		echo "<TABLE bgcolor=\"#3D2648\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"600\">";
			echo "<TR>";
				echo "<TD>";
					echo "<TABLE cellpadding=\"4\" cellspacing=\"1\" border=\"0\">";
						echo "<TR>";
							echo "<TH bgcolor=\"#9162AC\" width=\"600\" colspan=\"3\" align=\"left\">";
								echo "<FONT face=\"arial, verdana\" size=\"1\" color=\"yellow\"><B>List of all errors in projekt: </B></FONT>";
								echo "<FONT face=\"arial, verdana\" size=\"1\" color=\"white\"><B>". $this->project ."</B></FONT>";
							echo "</TH>";
					echo "</TR>";
						echo "<TR>";
							echo "<TH bgcolor=\"#9162AC\" width=\"100\"><FONT face=\"arial, verdana\" size=\"1\" color=\"white\"><B>Variable name</B></FONT></TH>";
							echo "<TH bgcolor=\"#9162AC\" width=\"200\"><FONT face=\"arial, verdana\" size=\"1\" color=\"white\"><B>Error location</B></FONT></TH>";
							echo "<TH bgcolor=\"#9162AC\" width=\"30\"><FONT face=\"arial, verdana\" size=\"1\" color=\"white\"><B>Error message</B></FONT></TH>";
					echo "</TR>";
					for($i=0; $i < $this->count; $i++) {
						echo "<TR>";
							echo "<TD bgcolor=\"#9162AC\" width=\"100\"><FONT face=\"arial, verdana\" size=\"2\"><B>" . $this->err[$i]["variable"] . "&nbsp;</B></FONT></TD>";
							echo "<TD bgcolor=\"#C6ADD3\" width=\"200\"><FONT face=\"arial, verdana\" size=\"2\">" . $this->err[$i]["location"] . "&nbsp;</FONT></TD>";
							echo "<TD bgcolor=\"#C6ADD3\" width=\"300\"><FONT face=\"arial, verdana\" size=\"2\">" . $this->err[$i]["message"] . "&nbsp;</FONT></TD>";
						echo "</TR>";
					}
					echo "</TABLE>";
				echo "</TD>";
			echo "</TR>";
		echo "</TABLE>";

	}
	/**********************
	* Return all errors
	* @return array of errors
	***/
	function getErrors() {
		return $this->err;
	}

	
	
	
	
	
}

?>