<?php
// On Site Repair class
class osr {
    var $id_wfinstance;
    var $interventions=array();

    /*
    constructor
    */
    function osr() {
            //arg 1 : $id
            $arguments = func_get_args();
            switch(func_num_args()) {
                    case 0:
                            //nothing to do
                            $this->id_wfinstance=0;
                            break;
                    case 1:
                            $this->id_wfinstance=$arguments[0];
                            break;
            }
            $this->load();
    }

    function load() {
        global $conn;
	if ($this->id_wfinstance>0) {
	    $sql="SELECT * FROM ".GALAXIA_TABLE_PREFIX."osr WHERE id_wfinstance=$this->id_wfinstance";
            if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
            while ($row=$res->FetchRow()) {
		$myintervention=new intervention($row);
		$this->interventions[]=$myintervention;
	    }
	}
    }
}

class intervention {
    var $intervention_id=0;
    var $id_wfinstance;
    var $technician;
    var $agreed_date;   // timestamp
    var $agreed_moment; // AM/PM
    var $timeleft;      // timestamp when left to customer
    var $timearrived;   // timestamp when arrived at customer
    var $workstarted;   // timestamp when work starts at customer
    var $workended;     // timestamp when work ends at customer
    var $distance;      // travelled distance
    var $note;

    /*
    constructor
    */
    function intervention() {
            $arguments = func_get_args();
            switch(func_num_args()) {
                    case 0:
                            //nothing to do
                            break;
                    default:
                            $this->load($arguments);
                            break;
            }
    }


    function load($row) {
		 $this->id_wfinstance=$row["id_wfinstance"];
		 $this->intervention_id=$row["intervention_id"];
		 $this->technician=$row["technician"];
		 $this->agreed_date=$row["agreed_date"];
		 $this->agreed_moment=$row["agreed_moment"];
		 $this->timeleft=$row["timeleft"];
		 $this->timearrived=$row["timearrived"];
		 $this->distance=$row["distance"];
		 $this->workstarted=$row["workstarted"];
		 $this->workended=$row["workended"];
		 $this->note=$row["note"];
    }

    function save() {
	global $conn;
	$vars=array('id_wfinstance','technician','agreed_date','agreed_moment','timeleft','timearrived','distance','workstarted','workended','note');
	foreach ($vars as $value) {
	    $$value=$conn->QMagic($this->$value);
	}
	
        if ($this->intervention_id >0) {
	    // then it is an update
	   $sql="UPDATE ".GALAXIA_TABLE_PREFIX."osr SET id_wfinstance=$id_wfinstance,technician=$technician,agreed_date=$agreed_date,agreed_moment=$agreed_moment,timeleft=$timeleft,timearrived=$timearrived,distance=$distance,workstarted=$workstarted,workended=$workended,note=$note WHERE intervention_id=$this->intervention_id";
	} else {
	   $sql="INSERT INTO ".GALAXIA_TABLE_PREFIX."osr (id_wfinstance,technician,agreed_date,agreed_moment,timeleft,timearrived,distance,workstarted,workended,note) VALUES ($id_wfinstance,$technician,$agreed_date,$agreed_moment,$start_date,$timeleft,$timearrived,$distance,$workstarted,$workended,$note)";
	}
    }

    function set($key,$value) {
        $this->$key=$value;
    }

}
?>
